//在项目代码覆写引擎renderFlow 这样打包微信 不需要使用本地引擎插件  加快加载 也方便升级引擎

let FlagOfset = 0;

const DONOTHING = 1 << FlagOfset++;
const BREAK_FLOW = 1 << FlagOfset++;
const LOCAL_TRANSFORM = 1 << FlagOfset++;
const WORLD_TRANSFORM = 1 << FlagOfset++;
const TRANSFORM = LOCAL_TRANSFORM | WORLD_TRANSFORM;
const UPDATE_RENDER_DATA = 1 << FlagOfset++;
const OPACITY = 1 << FlagOfset++;
const COLOR = 1 << FlagOfset++;
const OPACITY_COLOR = OPACITY | COLOR;
const RENDER = 1 << FlagOfset++;
const CHILDREN = 1 << FlagOfset++;
const POST_RENDER = 1 << FlagOfset++;
/**新增的部分 */
const CHILDREN_BATCH_RENDER = 1 << FlagOfset++;
/**新增的部分 */
const FINAL = 1 << FlagOfset++;



let _batcher, _forward;
let _cullingMask = 0;

function RenderFlow() {
    this._func = init;
    this._next = null;
}

let _proto = RenderFlow.prototype;
_proto._doNothing = function () {
};

_proto._localTransform = function (node) {
    node._updateLocalMatrix();
    node._renderFlag &= ~LOCAL_TRANSFORM;
    this._next._func(node);
};

_proto._worldTransform = function (node) {
    _batcher.worldMatDirty++;

    let t = node._matrix;
    let trs = node._trs;
    let tm = t.m;
    tm[12] = trs[0];
    tm[13] = trs[1];
    tm[14] = trs[2];

    node._mulMat(node._worldMatrix, node._parent._worldMatrix, t);
    node._renderFlag &= ~WORLD_TRANSFORM;
    this._next._func(node);

    _batcher.worldMatDirty--;
};

_proto._opacity = function (node) {
    _batcher.parentOpacityDirty++;

    node._renderFlag &= ~OPACITY;
    this._next._func(node);

    _batcher.parentOpacityDirty--;
};

_proto._color = function (node) {
    let comp = node._renderComponent;
    if (comp) {
        comp._updateColor();
    }

    node._renderFlag &= ~COLOR;
    this._next._func(node);
};

_proto._updateRenderData = function (node) {
    let comp = node._renderComponent;
    comp._assembler.updateRenderData(comp);
    node._renderFlag &= ~UPDATE_RENDER_DATA;
    this._next._func(node);
};

_proto._render = function (node) {
    let comp = node._renderComponent;
    comp._checkBacth(_batcher, node._cullingMask);
    comp._assembler.fillBuffers(comp, _batcher);
    this._next._func(node);
};


_proto._children = function (node) {
    let cullingMask = _cullingMask;
    let batcher = _batcher;

    let parentOpacity = batcher.parentOpacity;
    let opacity = (batcher.parentOpacity *= (node._opacity / 255));

    let worldTransformFlag = batcher.worldMatDirty ? WORLD_TRANSFORM : 0;
    let worldOpacityFlag = batcher.parentOpacityDirty ? OPACITY_COLOR : 0;
    let worldDirtyFlag = worldTransformFlag | worldOpacityFlag;

    let children = node._children;
    for (let i = 0, l = children.length; i < l; i++) {
        let c = children[i];

        // Advance the modification of the flag to avoid node attribute modification is invalid when opacity === 0.
        c._renderFlag |= worldDirtyFlag;
        if (!c._activeInHierarchy || c._opacity === 0) continue;

        _cullingMask = c._cullingMask = c.groupIndex === 0 ? cullingMask : 1 << c.groupIndex;

        // TODO: Maybe has better way to implement cascade opacity
        let colorVal = c._color._val;
        c._color._fastSetA(c._opacity * opacity);
        flows[c._renderFlag]._func(c);
        c._color._val = colorVal;
    }

    batcher.parentOpacity = parentOpacity;

    this._next._func(node);
};

/**主要新增的部分 */
let childrens = [];
let cqueue = [];
// 设置Label的Index
const LabelIndex = cc.Enum({
    NONE: 120,
    BITMAP: 100,
    CHAR: 110,
    BMFONT: 200
});

const CacheMode = cc.Enum({
    0: "NONE",
    1: "BITMAP",
    2: "CHAR",
});

let BMfonts = {}
let BMfontsNum = 0;

_proto._childrenBatchRender = function (node) {
    node._renderFlag &= ~CHILDREN;
    node._renderFlag |= CHILDREN_BATCH_RENDER;
    let cullingMask = _cullingMask;
    let batcher = _batcher;

    let parentOpacity = batcher.parentOpacity;
    let opacity = batcher.parentOpacity *= (node._opacity / 255);

    let worldTransformFlag = batcher.worldMatDirty ? WORLD_TRANSFORM : 0;
    let worldOpacityFlag = batcher.parentOpacityDirty ? COLOR : 0;
    let worldDirtyFlag = worldTransformFlag | worldOpacityFlag;

    let config = node.config;
    childrens.length = 0;
    cqueue.length = 0;
    Array.prototype.push.apply(cqueue, node._children);
    let ch = null;
    node._batcherOpactity = opacity
    while (cqueue.length > 0) {
        for (let i = 0, len = cqueue.length; i < len; i++) {
            ch = cqueue.shift();
            if (ch.active) {
                ch._batcherOpactity = ch.parent._batcherOpactity * (ch._opacity / 255)
                ch._color._fastSetA(ch._opacity * ch.parent._batcherOpactity);

                //缩放
                if (ch._localMatDirty==2) {
                    ch._children.forEach(child=>{
                        child.setLocalDirty(2)
                    })
                }

                ch._sortIndex = childrens.length
                childrens.push(ch);
                Array.prototype.push.apply(cqueue, ch._children);
            }
        }
    }

    childrens.sort((ch1, ch2) => {
        function _getRenderIndex(node) {
            const weight = 2000
            let name = node._name
            // 设置节点排序默认值为0
            let index = node._sortIndex
            if (config[name]) {
                index = config[name] + weight
            } else {
                // 自动处理一些label
                let label = node.getComponent(cc.Label)
                if (label) {
                    if (label.font) {
                        if (BMfonts[label.font.name]) {
                            index = BMfonts[label.font.name]
                        } else {
                            BMfonts[label.font.name] = weight + LabelIndex.BMFONT + BMfontsNum++;
                            index = BMfonts[label.font.name]
                        }
                    } else {
                        let cacheMode = label.cacheMode
                        index = LabelIndex[CacheMode[cacheMode]] + weight
                    }
                }
            }
            return index
        }

        return _getRenderIndex(ch1) - _getRenderIndex(ch2);
    });

    let children = childrens;
    for (let i = 0, l = children.length; i < l; i++) {
        let c = children[i];
        if (c.childrenCount > 0) {
            c._renderFlag &= ~CHILDREN;
        }
        // Advance the modification of the flag to avoid node attribute modification is invalid when opacity === 0.
        c._renderFlag |= worldDirtyFlag;
        if (!c._activeInHierarchy || c._opacity === 0) continue;

        _cullingMask = c._cullingMask = c.groupIndex === 0 ? cullingMask : 1 << c.groupIndex;

        // TODO: Maybe has better way to implement cascade opacity
        let colorVal = c._color._val;
        // c._color._fastSetA(c._opacity * opacity);
        flows[c._renderFlag]._func(c);
        if (c.childrenCount > 0) {
            c._renderFlag &= ~CHILDREN;
        }
        c._color._val = colorVal;
    }
    batcher.parentOpacity = parentOpacity;
    this._next._func(node);
}

/**新增的部分 */

_proto._postRender = function (node) {
    let comp = node._renderComponent;
    comp._checkBacth(_batcher, node._cullingMask);
    comp._assembler.postFillBuffers(comp, _batcher);
    this._next._func(node);
};

const EMPTY_FLOW = new RenderFlow();
EMPTY_FLOW._func = EMPTY_FLOW._doNothing;
EMPTY_FLOW._next = EMPTY_FLOW;

let flows = {};

function createFlow(flag, next) {
    let flow = new RenderFlow();
    flow._next = next || EMPTY_FLOW;

    switch (flag) {
        case DONOTHING:
            flow._func = flow._doNothing;
            break;
        case BREAK_FLOW:
            flow._func = flow._doNothing;
            break;
        case LOCAL_TRANSFORM:
            flow._func = flow._localTransform;
            break;
        case WORLD_TRANSFORM:
            flow._func = flow._worldTransform;
            break;
        case OPACITY:
            flow._func = flow._opacity;
            break;
        case COLOR:
            flow._func = flow._color;
            break;
        case UPDATE_RENDER_DATA:
            flow._func = flow._updateRenderData;
            break;
        case RENDER:
            flow._func = flow._render;
            break;
        case CHILDREN:
            flow._func = flow._children;
            break;
        case CHILDREN_BATCH_RENDER:
            flow._func = flow._childrenBatchRender;
            break;
        case POST_RENDER:
            flow._func = flow._postRender;
            break;
    }

    return flow;
}

function getFlow(flag) {
    let flow = null;
    let tFlag = FINAL;
    while (tFlag > 0) {
        if (tFlag & flag)
            flow = createFlow(tFlag, flow);
        tFlag = tFlag >> 1;
    }
    return flow;
}

// 
function init(node) {
    let flag = node._renderFlag;
    let r = flows[flag] = getFlow(flag);
    r._func(node);
}

RenderFlow.flows = flows;
RenderFlow.createFlow = createFlow;

RenderFlow.visitRootNode = function (rootNode) {
    _cullingMask = 1 << rootNode.groupIndex;

    if (rootNode._renderFlag & WORLD_TRANSFORM) {
        _batcher.worldMatDirty++;
        rootNode._calculWorldMatrix();
        rootNode._renderFlag &= ~WORLD_TRANSFORM;

        flows[rootNode._renderFlag]._func(rootNode);

        _batcher.worldMatDirty--;
    }
    else {
        flows[rootNode._renderFlag]._func(rootNode);
    }
};

RenderFlow.render = function (scene, dt) {
    _batcher.reset();
    _batcher.walking = true;

    RenderFlow.visitRootNode(scene);

    _batcher.terminate();
    _batcher.walking = false;

    _forward.render(_batcher._renderScene, dt);
};

RenderFlow.init = function (batcher, forwardRenderer) {
    _batcher = batcher;
    _forward = forwardRenderer;

    flows[0] = EMPTY_FLOW;
    for (let i = 1; i < FINAL; i++) {
        flows[i] = new RenderFlow();
    }
};

RenderFlow.getBachther = function () {
    return _batcher;
};

RenderFlow.FLAG_DONOTHING = DONOTHING;
RenderFlow.FLAG_BREAK_FLOW = BREAK_FLOW;
RenderFlow.FLAG_LOCAL_TRANSFORM = LOCAL_TRANSFORM;
RenderFlow.FLAG_WORLD_TRANSFORM = WORLD_TRANSFORM;
RenderFlow.FLAG_TRANSFORM = TRANSFORM;
RenderFlow.FLAG_OPACITY = OPACITY;
RenderFlow.FLAG_COLOR = COLOR;
RenderFlow.FLAG_OPACITY_COLOR = OPACITY_COLOR;
RenderFlow.FLAG_UPDATE_RENDER_DATA = UPDATE_RENDER_DATA;
RenderFlow.FLAG_RENDER = RENDER;
RenderFlow.FLAG_CHILDREN = CHILDREN;
/**新增的部分 */
RenderFlow.FLAG_CHILDREN_BATCH_RENDER = CHILDREN_BATCH_RENDER
/**新增的部分 */
RenderFlow.FLAG_POST_RENDER = POST_RENDER;
RenderFlow.FLAG_FINAL = FINAL;

cc.RenderFlow = RenderFlow;
