"use strict";
cc._RF.push(module, '939a0GgawNO2qyQxkQq8YXr', 'OptimizaDrawCall');
// OptimizaDrawCall/OptimizaDrawCall.ts

/**
 * @author 503722728@qq.com
 * drawcall 优化组件能轻松优化list相关label 图集相互打断导致的draw call很高
 * 如果因为使用对象池导致出现奇怪的bug 请在对象池取出对象时 手动重置一次item renderFlag
 * this.node._renderFlag = cc.RenderFlow.FLAG_CHILDREN
 */
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property, menu = _a.menu, executionOrder = _a.executionOrder, help = _a.help;
var containerZIndex = 1;
var OptimizeDrawCallOptions = /** @class */ (function () {
    function OptimizeDrawCallOptions() {
        /**
         * 待优化节点的路径，层级使用斜线分隔
         * 例如：nodeNameA/nodeNameB/nodeNameC
         */
        this.pathToNode = [""];
        /**
         * 记录上次的数组长度
         */
        this.oldLength = 1;
        /**
         * 分层节点的zIndex
         */
        this.containerZIndex = containerZIndex;
    }
    __decorate([
        property({
            type: cc.String,
            displayName: '待优化节点名',
            tooltip: '脚本节点下的节点名 优化节点不能重名'
        })
    ], OptimizeDrawCallOptions.prototype, "pathToNode", void 0);
    __decorate([
        property({
            type: cc.Integer,
            displayName: '分层节点zIndex',
            tooltip: '如层级不对，可自行调整，一般节点层级默认为0'
        })
    ], OptimizeDrawCallOptions.prototype, "containerZIndex", void 0);
    OptimizeDrawCallOptions = __decorate([
        ccclass("OptimizeDrawCallOptions")
    ], OptimizeDrawCallOptions);
    return OptimizeDrawCallOptions;
}());
exports.OptimizeDrawCallOptions = OptimizeDrawCallOptions;
var OptimizeDrawCall = /** @class */ (function (_super) {
    __extends(OptimizeDrawCall, _super);
    function OptimizeDrawCall() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.enabledOptimize = true;
        _this._options = [new OptimizeDrawCallOptions()];
        return _this;
    }
    Object.defineProperty(OptimizeDrawCall.prototype, "options", {
        get: function () {
            return this._options;
        },
        set: function (value) {
            if (CC_EDITOR) {
                value.forEach(function (op, i) {
                    var arr = op.pathToNode;
                    var last = arr[arr.length - 1];
                    // cc.error(JSON.stringify(value))
                    if (arr.length < op.oldLength) {
                        arr[arr.length - 1] = "";
                    }
                    else if (last != "") {
                        arr.push("");
                    }
                    op.oldLength = arr.length;
                });
                containerZIndex = value.length + 1;
            }
            this._options = value;
        },
        enumerable: true,
        configurable: true
    });
    OptimizeDrawCall.prototype.start = function () {
        if (!cc.sys.isNative)
            this._setNodeRender();
    };
    OptimizeDrawCall.prototype._setNodeRender = function () {
        if (!this.enabledOptimize) {
            // 是否开启优化
            return;
        }
        var config = {};
        this.options.forEach(function (nodeInfo) {
            if (nodeInfo)
                nodeInfo.pathToNode.forEach(function (name) {
                    // 添加特殊配置
                    if (name)
                        config[name] = nodeInfo.containerZIndex;
                });
        });
        var content = this.node;
        content._renderFlag &= ~cc.RenderFlow.FLAG_CHILDREN;
        content._renderFlag |= cc.RenderFlow.FLAG_CHILDREN_BATCH_RENDER;
        content.config = config;
    };
    __decorate([
        property({
            displayName: '开启优化',
            tooltip: '用于对比优化效果'
        })
    ], OptimizeDrawCall.prototype, "enabledOptimize", void 0);
    __decorate([
        property()
    ], OptimizeDrawCall.prototype, "_options", void 0);
    __decorate([
        property({
            type: OptimizeDrawCallOptions,
            displayName: '优化项',
            tooltip: '不同层级'
        })
    ], OptimizeDrawCall.prototype, "options", null);
    OptimizeDrawCall = __decorate([
        ccclass,
        menu("优化组件/DrawCall"),
        executionOrder(1)
    ], OptimizeDrawCall);
    return OptimizeDrawCall;
}(cc.Component));
exports.default = OptimizeDrawCall;

cc._RF.pop();